/* (C) Copyright 1984,85,86,87 Walter L. Peacock   All Rights Reserved    */

/* THIS PROGRAM BELONGS TO WALTER L. PEACOCK.  IT IS CONSIDERED A TRADE */
/* SECRET AND IS NOT TO BE DIVULGED OR USED BY PARTIES WHO HAVE NOT    */
/* RECEIVED WRITTEN AUTHORIZATION FROM THE OWNER.                   */

/* 09/11/87  D E L E T B T R . C   delete all btree nodes */

#include "cbtree.h"

#if CI | DC
#else
#include <ctype.h>
#endif

deletbtr(fd, findroot)    /* delete the B+tree at the given location */
int  fd;      /* file descriptor */
long findroot; /* byte offset to rootptr */
{
   extern long  lseek();
   extern char *calloc();
   extern void  delnode();
   BT_INFO    btinfo;   /* get info on specified btree */

   if (findroot == 0  || findroot == -1)   /* no entry or no file */
      return (0);                        /* unsuccesful */
   if (lseek(fd, findroot, 0) == -1L)
      ckerror(- CK_SEEK, "86");
   if (read(fd, (char *)&btinfo, SZ_BT_INFO) == ERR)   /* get tree info */
      ckerror(- CK_READ, "87");
   delnode(fd, btinfo.bi_rootp, (uint)btinfo.bi_blksz, (uint)btinfo.bi_kylen,
         (uint)btinfo.bi_cells);
   memset(btinfo.bi_bname, '?', SZ_BNAME); /* erase name */
   btinfo.bi_rootp = -1;            /* no root */
   if (lseek(fd, findroot, 0) == -1L)
      ckerror(- CK_SEEK, "69");
   if (write(fd, (char *)&btinfo, SZ_BT_INFO) == ERR)  /* delete entry */
      ckerror(- CK_WRIT, "73");
   return (1);   /* all ok */
}

void delnode(fd, recloc, idxlen, keylen, cells)   /* recursive */
int  fd;
long recloc;
uint idxlen;
uint keylen;
uint cells;
{
   extern char *calloc();
   BTIDXBLK *idxblkp;
   uint       u;

   u = sizeof(BTIDXBLK) + cells * sizeof(BTIDX);
   if ((char *)(idxblkp = (BTIDXBLK *)calloc(u, SZCHAR)) == NULL)
      ckerror(- CK_NOMEM, "88");
   getidxr(fd, recloc, idxblkp, idxlen, keylen);
   if (idxblkp->blktype == 0) /* index node */
   {
      for (u = 0; u < idxblkp->cellicnt; ++u)
         delnode(fd, idxblkp->btpage[u].btptr, idxlen, keylen, cells);
   }
   deletrec(fd, recloc, idxlen);
   freekeys(idxblkp);
   FREE(idxblkp);
}

#ifndef NOTEST

#include <stdio.h>
#include "btfio.h"

void main(argc, argv)
int  argc;
char *argv[];
{
   extern char *strcpy(), *strcat();
   extern int    strlen(), exit();
   BTC    btcommo;
   int  b, fd;
   char btname[14];

   if (argc > 1)
      strcpy(btname, argv[1]);
   else
   {
      printf("\n\nEnter B+tree Name (xxxxxxxx) ==> ");
      gets(btname);
   }
   repeat
   {
      if ((b = btrinit(btname, &btcommo)) == ERR)
      {
         printf("\nDELBTREE: entry for '%s' not found in BTPARMS.BTR",
                  btname);
         printf("\n\nEnter b-tree name (xxxxxxxx) ==> ");
         gets(btname);
         if (*btname == NUL  ||    toupper(*btname) == 'X')
            exit(0);
      }
   }
   until(b != ERR);

   if ((fd = bt_open(btcommo.idxname, O_RDWR)) == ERR)
      printf("Index file '%s' NOT found... \n\n", btcommo.idxname);
   else
   {
      b = deletbtr(fd, btcommo.findroot);
      close (fd);
   }
   printf("\nB+tree '%s' %sdeleted successfully in file '%s'.\n\n",
      btname, b ? "" : "NOT ", btcommo.idxname);
}

#endif

